/*
 * @copyright		 Copyright 2006-2022, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.googlesmartshopping.ui.confirmationdialog
 */

define("de_epages/googlesmartshopping/ui/confirmationdialog", [
  "jquery",
  "ep",
  "$dict!ep/dict",
  "jquery/ui/draggable",
  "ep/ajax",
  "ep/fn/busy",
  "ep/ui/dialog"
], function ($, ep, epDict) {

/*
   * @dictionary      ep.dict
   *
   * @translation     {Cancel}
*/

  var confirmationdialog;

  return (confirmationdialog = {
    ShopObjectId: null,

    ConfirmationDialog: null,

    open: function (data) {
      var dialogSelector = $(data.dialogClass);
      this.ConfirmationDialog = dialogSelector
        .html( '<p>' + data.text.DialogMessage1 + '</p>' +
          '<p>' + data.text.DialogMessage2 + '</p>' )
        .uiDialog({
          title: data.text.DialogTitle,
          modal: true,
          autoOpen: false,
          draggable: true,
          resizable: false,
          width: 600,
          maxHeight: 600,
          buttons: [{
            cssClass: 'ep-button ep-button-save',
            text: data.text.DialogCommitButton,
            click: function () {
              confirmationdialog.submit(data);
              confirmationdialog.close();
            }
          }, {
            cssClass: 'ep-button ep-button-cancel',
            text: epDict.translate('{Cancel}'),
            click: function () {
              confirmationdialog.close();
            }
          }],
        });

      this.ConfirmationDialog.uiDialog('open');
    },

    submit: function (data) {
      ep('body').busy('show');

      ep.ajax({
        url: "?ChangeAction=" + data.changeAction + "&ObjectID=" + data.objectId,
        type: "POST"
      }).always(function () {
        ep('body').busy('hide');
        $(data.submitForm).submit();
      });
    },

    close: function () {
      this.ConfirmationDialog.uiDialog('close');
    }
  });
});
