/*globals require*/
require([
    'jquery',
    'testsuite/qunit',
    'testsuite/sinon',
    'de_epages/product/inc/variationuploadimages',

    '$ready!'
], function ($, Q, sinon, setup) {
    'use strict';

    var fixture = $('#qunit-fixture');

    Q.module('product/inc/variationuploadimages', {
        setup: function () {

        },
        teardown: function () {

        }
    });

    Q.test('Check HTML structure and visible options', 10, function () {

        var optGroup1 = "Size",
            optGroup2 = "Color";

        setup({
            ObjectID: 1337,
            optgroup:
                '<optgroup data-alias=' + optGroup1 + ' label=' + optGroup1 + '>' +
                    '<option value="1" label="S">S</option>' +
                     '<option value="12" label="M">M</option>' +
                    '<option value="123" label="L">L</option>' +
                '</optgroup>' +
                '<optgroup data-alias=' + optGroup2 + ' label=' + optGroup2 + '>' +
                    '<option value="321" label="Red">Red</option>' +
                    '<option value="32" label="Black">Black</option>' +
                    '<option value="3" label="White">White</option>' +
                '</optgroup>',
            productImageLarge: {
                width: 1920,
                height: 1080
            },
            masterProductImage: 'Image.jpg'
        });


        Q.ok(
            $('.ui-dialog').length,
            'Dialog is created'
        );

        Q.ok(
            $('.Left').length,
            'Found `Left` node'
        );

        Q.ok(
            $('.Right .ep-uiUploadImage').length,
            'Found node epUiUploadImage'
        );

        Q.ok(
            $('.Right .ep-uiUploadImage-Container').length,
            'Found node .ep-uiUploadImage-Container'
        );

        Q.ok(
            $('.Right .ep-uiUploadImage-Options').length,
            'Found node .ep-uiUploadImage-Options'
        );

        Q.ok(
            $('.Right button.de_epages-presentationUiUploader-button.Disabled').prop('disabled'),
            'Found button, initially disabled'
        );

        Q.ok(
            $('.Left select optgroup[data-alias=' + optGroup1 + ']').length,
            'First optgroup found within `select` element'
        );

        Q.ok(
            $('.Left select optgroup[data-alias=' + optGroup2 + ']').length,
            'Second optgroup found within `select` element'
        );

        Q.ok(
            $('.Right').data('uiPresentationUiUploadImage'),
            'We have an uploader iniitalized'
        );

        Q.strictEqual(
            $('.ep-uiUploadImage-Container > img').attr('src'),
            'Image.jpg',
            'Image is passed correctly'
        );
    });
});